import os
import re
import urllib
from htmlentitydefs import name2codepoint
from traceback import print_exc
import time
import xbmc

__useragent__    = "Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.1) Gecko/2008070208 Firefox/3.0.1"

cache_dir = os.path.join( xbmc.translatePath("special://masterprofile/") , "cache" )

def debug(logLine):
    if os.environ.has_key("debug.mangastv"):
        print "[DEBUG] %s" % logLine

def unescapeHTMLchar(fullString):
    match = re.search("&(#\d+|#x[0-9a-fA-F]+|\w+);", fullString)
    while match is not None:
        toReplace = match.group(1)
        repl = unichr(name2codepoint[toReplace])
        fullString = re.sub(match.group(0), repl, fullString)
        match = re.search("&(#\d+|#x[0-9a-fA-F]+|\w+);", fullString)
    return fullString

              
def downloadHTML( url ):
    """ fetch the html source """
    class AppURLopener(urllib.FancyURLopener):
        version = __useragent__
    urllib._urlopener = AppURLopener()

    try:
        if os.path.isfile( url ): sock = open( url, "r" )
        else:
            urllib.urlcleanup()
            sock = urllib.urlopen( url )

        htmlsource = sock.read()
        sock.close()
        htmlsource = unicode(htmlsource, 'utf-8', 'replace')
        return htmlsource
    except:
        print_exc()
        print "impossible d'ouvrir la page %s" % url
        return ""

def isCacheValid(cachefile, max_age = 24*3600):
    if os.path.exists(cachefile):
        cache_modified_time = os.stat(cachefile).st_mtime
        time_now = time.time()
        if cache_modified_time < time_now - max_age:
            return False
        else:
            return True
    else:
        return False

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False
